Gecode::Int::Element::Pair Class Reference
Other available functionality » Integer propagators

Domain consistent pair propagator. More...

`#include <element.hh>`

## Public Member Functions

| Pair (Home home, IntView x0, IntView x1, IntView x2, int w)
| Constructor for posting.
virtual Actor * | copy (Space &home)
| Copy propagator during cloning.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
Public Member Functions inherited from Gecode::TernaryPropagator< IntView, PC_INT_DOM >
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as low ternary).
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, IntView x0, IntView x1, IntView x2, int w, int h)
| Post propagator .
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

| Pair (Space &home, Pair &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::TernaryPropagator< IntView, PC_INT_DOM >
| TernaryPropagator (Space &home, TernaryPropagator &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

int | w
| Width.
Protected Attributes inherited from Gecode::TernaryPropagator< IntView, PC_INT_DOM >
IntView | x0
| Three views.
IntView | x1
IntView | x2

## Detailed Description

Domain consistent pair propagator.

Requires

#include <gecode/int/element.hh>
element.hh

Definition at line 297 of file element.hh.

## Constructor & Destructor Documentation

## Pair() [1/2]

Gecode::Int::Element::Pair::Pair | ( | Space & | home,
|  | Pair & | p )

inline protected

Constructor for cloning p.

Definition at line 64 of file pair.hpp.

## Pair() [2/2]

Gecode::Int::Element::Pair::Pair | ( | Home | home,
|  | IntView | x0,
|  | IntView | x1,
|  | IntView | x2,
|  | int | w )

inline

Constructor for posting.

Definition at line 39 of file pair.hpp.

## Member Function Documentation

## post()

ExecStatus Gecode::Int::Element::Pair::post | ( | Home | home,
|  | IntView | x0,
|  | IntView | x1,
|  | IntView | x2,
|  | int | w,
|  | int | h )

inline static

Post propagator .

Definition at line 43 of file pair.hpp.

## copy()

Actor * Gecode::Int::Element::Pair::copy | ( | Space & | home | ) |

virtual

Copy propagator during cloning.

Implements Gecode::Actor.

Definition at line 39 of file pair.cpp.

## propagate()

ExecStatus Gecode::Int::Element::Pair::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 97 of file pair.cpp.

## Member Data Documentation

## w

int Gecode::Int::Element::Pair::w

protected

Width.

Definition at line 304 of file element.hh.

The documentation for this class was generated from the following files:

- gecode/int/element.hh
- gecode/int/element/pair.cpp
- gecode/int/element/pair.hpp